package com.liang.dao;

import com.liang.entity.StaSchedule;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 进度安排(StaSchedule)表数据库访问层
 *
 * @author makejava
 * @since 2023-04-09 22:07:01
 */
public interface StaScheduleDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaSchedule queryById(Integer id);

    /**
     * 通过主表查询数据
     *
     * @param zb 主键
     * @return 实例对象
     */
    List<StaSchedule> queryByZbId(Integer zb);

    /**
     * 查询指定行数据
     *
     * @param staSchedule 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<StaSchedule> queryAllByLimit(StaSchedule staSchedule, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staSchedule 查询条件
     * @return 总行数
     */
    long count(StaSchedule staSchedule);

    /**
     * 新增数据
     *
     * @param staSchedule 实例对象
     * @return 影响行数
     */
    int insert(StaSchedule staSchedule);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaSchedule> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StaSchedule> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaSchedule> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaSchedule> entities);

    /**
     * 修改数据
     *
     * @param staSchedule 实例对象
     * @return 影响行数
     */
    int update(StaSchedule staSchedule);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 根据主表id删除记录
     *
     * @param zbId
     * @return
     */
    int deleteByZbId(Integer zbId);
}

